Transformation (Apache Tomcat 11.0.23 API Documentation)
Description: declaration: package: org.apache.tomcat.websocket, interface: Transformation

# Interface Transformation

All Known Implementing Classes:
  `PerMessageDeflate`

public interface Transformation
The internal representation of the transformation that a WebSocket extension performs on a message.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `close()`
  Clean-up any resources that were used by the transformation.
  `Extension`
  `getExtensionResponse()`
  Obtain the extension that describes the information to be returned to the client.
  `TransformationResult`
  `getMoreData(byte opCode, boolean fin, int rsv, ByteBuffer dest)`
  Obtain more input data.
  `List<MessagePart>`
  `sendMessagePart(List<MessagePart> messageParts)`
  Takes the provided list of messages, transforms them, passes the transformed list on to the next transformation (if any) and then returns the resulting list of message parts after all of the transformations have been applied.
  `void`
  `setNext(Transformation t)`
  Sets the next transformation in the pipeline.
  `boolean`
  `validateRsv(int rsv, byte opCode)`
  Validates the RSV and opcode combination (assumed to have been extracted from a WebSocket Frame) for this extension.
  `boolean`
  `validateRsvBits(int i)`
  Validate that the RSV bit(s) required by this transformation are not being used by another extension.

- ## Method Details

  - ### setNext

    void setNext(Transformation t)
    Sets the next transformation in the pipeline.
    Parameters:
      `t` - The next transformation

  - ### validateRsvBits

    boolean validateRsvBits(int i)
    Validate that the RSV bit(s) required by this transformation are not being used by another extension. The implementation is expected to set any bits it requires before passing the set of in-use bits to the next transformation.
    Parameters:
      `i` - The RSV bits marked as in use so far as an int in the range zero to seven with RSV1 as the MSB and RSV3 as the LSB
    Returns:
      `true` if the combination of RSV bits used by the transformations in the pipeline do not conflict otherwise `false`

  - ### getExtensionResponse

    Extension getExtensionResponse()
    Obtain the extension that describes the information to be returned to the client.
    Returns:
      The extension information that describes the parameters that have been agreed for this transformation

  - ### getMoreData

    TransformationResult getMoreData(byte opCode, boolean fin, int rsv, ByteBuffer dest) throws IOException
    Obtain more input data.
    Parameters:
      `opCode` - The opcode for the frame currently being processed
      `fin` - Is this the final frame in this WebSocket message?
      `rsv` - The reserved bits for the frame currently being processed
      `dest` - The buffer in which the data is to be written
    Returns:
      The result of trying to read more data from the transform
    Throws:
      `IOException` - If an I/O error occurs while reading data from the transform

  - ### validateRsv

    boolean validateRsv(int rsv, byte opCode)
    Validates the RSV and opcode combination (assumed to have been extracted from a WebSocket Frame) for this extension. The implementation is expected to unset any RSV bits it has validated before passing the remaining RSV bits to the next transformation in the pipeline.
    Parameters:
      `rsv` - The RSV bits received as an int in the range zero to seven with RSV1 as the MSB and RSV3 as the LSB
      `opCode` - The opCode received
    Returns:
      `true` if the RSV is valid otherwise `false`

  - ### sendMessagePart

    List<MessagePart> sendMessagePart(List<MessagePart> messageParts) throws IOException
    Takes the provided list of messages, transforms them, passes the transformed list on to the next transformation (if any) and then returns the resulting list of message parts after all of the transformations have been applied.
    Parameters:
      `messageParts` - The list of messages to be transformed
    Returns:
      The list of messages after this and any subsequent transformations have been applied. The size of the returned list may be bigger or smaller than the size of the input list
    Throws:
      `IOException` - If an error occurs during the transformation of the message parts

  - ### close

    void close()
    Clean-up any resources that were used by the transformation.